Scriptname WZones_RandomEnabler extends ObjectReference  

{
WZ RANDOM ENABLE TOGGLE with CONDITION CHECKS

	Place this on a XMARKER or ACTIVATOR to randomly determine whether it's CHILDREN should be ENABLED
	Can be used as WZ GARRISON.
	
	Functions:
	
	1 - Allows for DEVELOPER ODDS OFFSET via PROPERTIES.  100 = Always On unless other conditions disable it.
	
	2 - Checks for CW STATUS and whether it matters.  As such, it can be a PARENT to a WZ but will not have GARRISON ENABLE or BATTLE SELECT.
		Use CWGETSTATUS for larger, named WZs that need specific GARRISON Conditions
	
	The primary difference between this and the CWGETSTATUS script is that this one doesn't have a GARRISON ENABLE or BATTLE SELECT
	WZs attached to this go on/off with the RANDOMENCOUNTER setting.

}

; ======== GLOBALS, VARIABLES, ETC...

Int Property RandomChanceOffset Auto  
	{ ;==== DEVELOPER inputs value to increase odds of ENABLE }
Bool Property DoesCWMatterInThisLocation Auto 
	{ ; ---- Determines if CW check is necessary.  Use for NonCW WZs. }
Bool Property ShouldThisLocationONLYSpawnAtNight Auto 
	{ ; ----- In WZs with VAMPIRES/WEREWOLVES this should be TRUE }
GlobalVariable Property FeatureOverride_gVarToggle Auto 
	{ ; = Did the player disable the feature you point to in PROPERTIES? }


;= Hidden gVars
GlobalVariable Property WZonesSpawnCount  Auto hidden  
	{ ; === Base Spawn count per NPC }
GlobalVariable Property WZonesSpawnCountSONS  Auto hidden  
	{ ; === Spawn count per STORMCLOAK NPC }
GlobalVariable Property WZonesSpawnCountIMPS  Auto hidden 
	{ ; === Spawn count per IMPERIAL NPC }
GlobalVariable Property WZonesAdvantage Auto hidden
	{ ; ==== Who has the ADVANTAGE  }
GlobalVariable Property WZonesRandomEncounters Auto hidden
	{ ; === ( 0 = OFF, 1 = ON) }
GlobalVariable Property WZonesRandomEncounterOdds Auto hidden
	{ ; === Utilize the PLAYER'S "ODDS" choice in addition to the developer's setting }
GlobalVariable Property WZonesOverride Auto 
	{ ; === Overrides everything and displays all battles. }
GlobalVariable Property WZonesCWStatus Auto hidden  
	{ ; === Checks status of CW.  This is mostly obsolete now that everything is parented, but still, gonna keep it for the few nonCW WZs }
GlobalVariable Property WZonesCWTruce Auto hidden 
	{ ; === Checks for CW Truce }
GlobalVariable Property GameHour Auto hidden
	{ ; === Duh. }
GlobalVariable Property WZonesDebugMsg Auto hidden
	{ ; === Sets WZ DebugTrace Messages (0 = Off, 2 = Primary MSGs on, 3 = All MSGS on) }

Quest Property CWObj Auto hidden
Quest Property MQ302 Auto hidden 
	{ ;  = Checks the CW TRUCE.  300 = TRUCE }
Quest Property MQ305 Auto hidden
	{ ; = Checks whether Alduin has been killed therefore TRUCE is over }

bool Property SPAWN_Use_FeatureOverrideGVar_Value_for_SpawnChancePercentage = False Auto
	{ Default = False.  OVERRIDES RANDOM CHANCE OFFSET.  Allow the value of the FEATURE OVERRIDE GVAR to serve as a randomSpawnPercentage.  ie: if the GVAR = 50, there will be a 50% chance of spawning.}
	
	
Event OnCellAttach()

;------- Check END of CIVIL WAR regardless of winner

	if (CWOBJ.GetStageDone(255))
		WZONESCWStatus.setValue(1)
	endif
	
	 if (MQ302.GetStageDone(300)) 
		 WZONESCWTruce.setValue(1)
			If WZonesCWTruce.getValue() == 1 && (MQ305.GetStageDone(200))
			WZonesCWTruce.setValue(0)
			Else
			EndIf
		Else
	 EndIf	

;-------- THE MEAT AND POTATOES

	
 	int randomDiceRoll = Utility.RandomInt (1, 100) ; Roll the Dice for a 1 in 100 chance that there should be an encounter.
	int randomEncounterOdds = WZonesRandomEncounterOdds.Value As Int ; USER INPUT number
	
	If SPAWN_Use_FeatureOverrideGVar_Value_for_SpawnChancePercentage
		RandomChanceOffset = FeatureOverride_gVarToggle.Value as Int
	EndIf
		
									;If WZonesDebugMsg.Value >= 1	
										;debug.Trace ("WZMSG[1] : RandomEnabler : PLAYER has ENTERED a rENCOUNTER/WZ controlled by FEATURE : " + FeatureOverride_gVarToggle +" @ " +GetParentCell())
										If WzonesDebugMsg.Value >= 2	
											debug.Trace ("WZMSG[2] : RandomEnabler : " +GetParentCell()+ " : RandomDICEroll = " + randomDiceRoll)
											debug.Trace ("WZMSG[2] : RandomEnabler : " +GetParentCell()+ " : EncounterOdds + DevOffset = " + (randomEncounterOdds + RandomChanceOffset))
										EndIf
									;Else
									;Endif
			
;------ CONDITIONS	
	
	If WZonesOverride.getValue() == 666 || FeatureOverride_gVarToggle.getValue() == 0 ; Is WZ Overridden by 666 or by FeatureOveride?
				While Self.Is3DLoaded()
				disable()
				EndWhile
									If WZonesDebugMsg.Value >= 1
										debug.Trace ("WZMSG[1] : RandomEnabler : " +GetParentCell()+ " : rENCOUNTER/WZ DISABLED by OVERRIDE 666 or " + FeatureOverride_gVarToggle )
									Else
									Endif
					;gotoState ("doneOnce")
					
	ElseIf (DoesCWMatterInThisLocation == true && WZonesCWStatus.getValue() == 1) || (DoesCWMatterInThisLocation == true && WZONESCWTruce.getValue() == 1)
				While Self.Is3DLoaded()
				disable()
				EndWhile
									If WZonesDebugMsg.Value >= 1
									debug.Trace ("WZMSG[1] : RandomEnabler : " +GetParentCell()+ " : rENCOUNTER/WZ DISABLED by CW STATUS")
									Else
									Endif
					;gotoState ("doneOnce")
				
	ElseIf randomEncounterOdds + RandomChanceOffset <= randomDiceRoll ; Did the Random Number Generate a NO SPAWN Condition?

				While Self.Is3DLoaded()	
				disable()
				EndWhile
									If WZonesDebugMsg.Value >= 1	
									debug.Trace ("WZMSG[1] : RandomEnabler : " +GetParentCell()+ " : rENCOUNTER/WZ DISABLED : High Dice")
									Else
									Endif	
					;gotoState ("doneOnce")	
		
	ElseIf ShouldThisLocationONLYSpawnAtNight == true
		If GameHour.GetValue() > 18.0 || GameHour.GetValue() < 7.0 ; Is It Night?
				While !Self.Is3DLoaded()	
				enable()
				EndWhile
									If WZonesDebugMsg.Value >= 1	
									debug.Trace ("WZMSG[1] : RandomEnabler : " +GetParentCell()+ " : NIGHT rENCOUNTER/WZ ENABLED @ " + Gamehour.GetValue())
									Else
									Endif
					;gotoState ("doneOnce")
		Else
				While Self.Is3DLoaded()	
				disable()
				EndWhile
									If WZonesDebugMsg.Value >= 1	
									debug.Trace ("WZMSG[1] : RandomEnabler : " +GetParentCell()+ " : NIGHT rENCOUNTER/WZ DISABLED by Daylight @ " + Gamehour.GetValue())
									Else
									Endif
					;gotoState ("doneOnce")
		EndIf
		
	Else
				While !Self.Is3DLoaded()

				enable()
				EndWhile
									If WZonesDebugMsg.Value >= 1	
									debug.Trace ("WZMSG[1] : RandomEnabler : " +GetParentCell()+ " : rENCOUNTER/WZ ENABLED")
									Else
									Endif
					;gotoState ("doneOnce")
	EndIf
	gotoState ("doneOnce")				
EndEvent

State doneOnce
	; Extra Stopgap
	; Do Nothing until reset
	Event OnBeginState()
		If WZonesDebugMsg.Value >= 4	
			debug.Trace ("WZMSG[4] : RandomEnabler : State DoneOnce")
		Else
		Endif
	EndEvent
	
	Event OnUnload()
				While Self.Is3DLoaded()
				disable()
				EndWhile
									If WZonesDebugMsg.Value >= 4
									debug.Trace ("WZMSG[4] : RandomEnabler : " +GetParentCell()+ " : PLAYER Exited rENCOUNTER/WZ : Disable")
									EndIf		
	EndEvent	
EndState