Scriptname WZONESSpawnOMany extends ObjectReference 
{
	WARZONES STEP TWO : Attached ONLY to ENABLE PARENTED WZNPCs.
	Determines amount of WZNPCs to spawn per point/marker and does so via PLACEATME.
	The PLACEATME WZNPCs are Orphans and therefore need to be disabled via the WZONES_childDisabler script.

	WARZONES : SPAWN O MANY
	What this does is take the WZONESSPAWNCOUNT and spawns that amount of NPCS from one NPC.
	The NPC WZONESvSPAWN does not exist, BUT is called to the specific "self" of each ACTOR it's attached to via PROPERTIES
	So, REMEMBER to point WZONESvSPAWN to the ACTOR you are trying to duplicate.

	Also, annoyingly, the PLACEATME function on its own does NOT take into account the ENABLE STATUS of the PARENT, so we have to see what the PARENT is up to via script and tell the CHILD what to do.

}

;============= GLOBALS, PROPERTIES and BOOLS, baby... yeah.
	 
	GlobalVariable Property WZonesSpawnCount Auto 
		{ ; === Global variable where iX is stored }
	GlobalVariable Property WZonesSpawnCountMax Auto 
		{ ; === Clamps the Maximum allowed Spawns. }
	GlobalVariable Property WZonesDebugMsg Auto 
		{ ; === Variable levels of debug messages (0 = off, 1 = Main MSGs, 2 = Add'l MSGs) }

	GlobalVariable Property WZonesPerformanceMode Auto
		{ Used to add an increased chance of NOSPAWN to aid in systems that have trouble on SPAWNCOUNT 1 }

	ActorBase Property WZONESvSPAWN Auto 
		{ ; === The actor type to spawn }

	GlobalVariable Property WZonesAdvantage Auto ;	
	GlobalVariable Property WZonesDisadvantage Auto ;
	{ADVANTAGE/DISADVANTAGE FACTION SETTINGS
	 This system can be extended as necessary with add'l Factions.
	 It compares the NPC FACTION (devset) with the DISADVANTAGED FACTION and if they match, the PENALTY is applied
	
			;------- WZ FACTION SETTINGS
				; 0 = NONE
				; 1 = IMPERIALS
				; 2 = STORMCLOAKS
				; 3 = BANDIT
				; 4 = FORSWORN
				; 5 = AFFLICTED
				; 6 = UNDEAD, MAGES, DRAUGR
				; 7 = BaseGame VAMPIRES
				; 8 = BaseGame VIGILANTS OF STENDARR
				; 9 = BaseGame WEREWOLVES
				
				; 17 = SILVER HAND
				; 18 = WHITERUN GUARDS
				; 19 = DWEMER (in case you ever get Power-Supplies working)
				; 20 = Lesser Used Factions.  Dunmer, Redguard, Witches, etc. }
				
	int Property NPCFaction Auto ; 
		{ DevSet NPC Faction.  Same value list as WZONESADVANTAGE }
	int Property AdvantagePenalty = 5 Auto ; DevSet Penalty for being Disadvantaged.  Lower is WORSE.
			{ DEFAULT = 5 : basically 50% more likely to NOT SPAWN if a faction is disadvantaged.
			1 = NoSpawns : 10 = Full Spawns
			This allows for "deeper" penalties, set by the Developer.
			By default, when there is no disadvantage, there is a 1 in 10 chance that a Unit won't spawn via this script.
			For instance, should the Developer determine that the penalty for being disadvantaged will be that NO SPAWNS happen, then this is set to 1.
			Logic being that the script is looking for a return value of 1 in order to not spawn.
			The larger the differential in the randomChanceofNoSpawn, the more chance an NPC WILL SPAWN.
			See? }

	float Property RespawnWaitTime = 1.5 Auto hidden
		{ OBSOLETE : DEFAULT = 1.5 GAME HOURS. How long to wait after spawning to see about spawning again.  Should help with cooldown in areas that have WZs directly adjacent to interiors.	11/25/14 : This seems to "cause" Stack Overflows with all the scripts waiting, so I "commented" it.  The original placement - outside the IF seemed to work, but my concern is that it's leave scripts in the queue when there's really no upside... moving it into the "If - Placeatme" and adding a GVAR just fucked it up more, so let's leave it off and if the WZs don't cooldown, oh well... better than Papyrus having a shit fit, no?  yes.  Anyway, leaving this here in case I want to revisit. }
	
;=========== EVENTS

Event OnLoad()
	
	If parent.isEnabled()
			
	; ==== MAX SPAWN Clamp
			If WZonesSpawnCount.Value > WZonesSpawnCountMax.Value
				WZonesSpawnCount.Value = WZonesSpawnCountMax.Value
					debug.Notification ("WARZONES REALITY CHECK")
					debug.Notification ("Calm down, Cowboy!")
					debug.Notification ("We know you're tough, but let's bring that")
					debug.Notification ("SpawnCount back down so you don't break anything.")
					
					If WZonesDebugMsg.Value >= 1
					debug.Trace ("WZMSG[1] : SpawnOMany : Clamped SpawnCount for safety.  Player exceeded Max Spawns.  Calm down, cowboy.")
					endif
			Endif
	
	; ==== RANDOMIZER and DISADVANTAGE CHECK
	
			int WZDisadvantage = WZonesDisadvantage.getValueInt()
			int WZPerformanceMode = WZonesPerformanceMode.getValueInt()

		;=== CHECKERS!
		;=== First, check for PERFORMANCE MODE.
		;=== This can effectively reduce NPC spawnChance to half.
		;=== Overrides the DISADVANTAGE to spawned population, but for players who need this, it'll hardly matter.
		
			If WZPerformanceMode == 1
			
				float randomChanceofNoSpawn = Utility.RandomInt (1, 2)  			
					If randomChanceofNoSpawn as int != 1

						int iX = WZonesSpawnCount.Value As Int ; read the value from the global
						If iX < 0
						iX = 0
						Endif
								
					PlaceAtMe(WZONESvSPAWN, iX)				

							If WZonesDebugMsg.Value >= 4
							debug.Trace ("WZMSG[4] : SpawnOMany : Performance Mode : WZ SPAWNED the GRANDKIDS " + iX As String)
							Endif
						
					Endif	
			
		; ==== DISADVANTAGE CHECK.
		; ==== This REDUCES the amount of SPAWNS for the DISADVANTAGED Faction
			ElseIf WZDisadvantage == NPCFaction
		
							If WZonesDebugMsg.Value >= 3
							debug.Trace ("WZMSG[3] : SpawnOMany : DISADVANTAGED FACTION " + NPCFaction)
							Endif	
							
					float randomChanceofNoSpawn = Utility.RandomFloat (1.0, AdvantagePenalty)  			
					If randomChanceofNoSpawn as int != 1

						int iX = WZonesSpawnCount.Value As Int ; read the value from the global
						If iX < 0
						iX = 0
						Endif
								
					PlaceAtMe(WZONESvSPAWN, iX)				

							If WZonesDebugMsg.Value >= 4
							debug.Trace ("WZMSG[4] : SpawnOMany : WZ SPAWNED the GRANDKIDS " + iX As String)
							Endif
						
					Endif	
															
		;==== BUSINESS as USUAL
	
			Else 
						
					float randomChanceofNoSpawn = Utility.RandomFloat (1.0, 10.0)   ; A 1 in 10 chance that there should be no spawn
					If randomChanceofNoSpawn as int != 1

						int iX = WZonesSpawnCount.Value As Int ; read the value from the global
						If iX < 0
						iX = 0
						Endif
								
					PlaceAtMe(WZONESvSPAWN, iX)

					Endif	
					
			Endif

	;Utility.WaitGameTime(RespawnWaitTime)
	Else		
	Endif

Endevent
